﻿using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

public partial class AdminCommandes : System.Web.UI.Page
{
 protected void Page_Load(object sender, EventArgs e)
 {
  if (IsPostBack == false) AfficherCommandes();
 }

 protected void AfficherCommandes()
 {
  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString ;
  DbDataAdapter oDA = dbpf.CreateDataAdapter();
  oDA.SelectCommand = oConn.CreateCommand();

  oDA.SelectCommand.CommandText = "SELECT Ouvrages.ISBN, Ouvrages.Titre, "
                     + " Clients.ID, Clients.NOM, Clients.PRENOM, Clients.ADRESSE, Clients.CP, Clients.LOCALITE, Clients.PAYS, "
                     + "Clients.EMAIL, "
                     + "Clients.CCTYPE, Clients.CCNUM, Clients.CCEXPMOIS, Clients.CCEXPANNEE, "
                     + "Commandes.NumCommande, Commandes.DateCommande, Commandes.Etat, Commandes.DateTraitement, Commandes.Commentaire "
                     + "FROM Ouvrages, Commandes, Clients "
                     + " WHERE Ouvrages.ISBN=Commandes.ISBN AND Clients.ID = Commandes.IDClient ";
  DataSet oDS = new DataSet();
  oDA.Fill(oDS, "Commandes");
  dlCommandes.DataSource = oDS.Tables["Commandes"];
  dlCommandes.DataBind();
 }
 protected string retDateCommande()
 {
  DateTime dt = (DateTime)Eval("DateCommande");
  return dt.ToShortDateString();
 }
 protected string retEtatCommande()
 {
  string s = "";
  int iEtat = (int)Eval("Etat");
  DateTime? dtn = Eval("DateTraitement") as DateTime?;
  
  switch (iEtat)
  {
   case 0 : s = "pas encore traitée"; break;
   case 1 :
    s = "expédié le ";
    if (dtn.HasValue) s += dtn.Value.ToShortDateString();
    break;
   case 2 : s = "En attente réapprovisionnement"; break;
   case 3: s = "Commande refusée"; break;
  }
  return s;
 }
 protected void dlCommandes_ItemCommand(object source, DataListCommandEventArgs e)
 {
  string sCommentaire="";
  TextBox ze=null;

  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString;
  oConn.Open();

  int nCommande = Int32.Parse(e.CommandArgument.ToString());
  DbCommand oCmd = oConn.CreateCommand();

  ze = e.Item.FindControl("zeMotif") as TextBox;
  if (ze != null) sCommentaire = ze.Text;
  
  switch (e.CommandName)
  {
   case "Supprimer" :
    oCmd.CommandText = "DELETE FROM Commandes WHERE NumCommande = " + nCommande; break;
   case  "Expédié" :
    oCmd.CommandText = "UPDATE Commandes SET Etat = 1, DateTraitement=#"
                      + DateTime.Now.Month + "/" + DateTime.Now.Day + "/" + DateTime.Now.Year + "#, "
                      + "Commentaire ='" + sCommentaire + "' "
                      + "WHERE NumCommande = " + nCommande;
    break;
   case "Attente" :
    oCmd.CommandText = "UPDATE Commandes SET Etat = 2, "
                       + "Commentaire ='" + sCommentaire + "' "
                       + "WHERE NumCommande = " + nCommande;
    break;
   case "Refus" :
    oCmd.CommandText = "UPDATE Commandes SET Etat = 3, Commentaire='" + sCommentaire + "' WHERE NumCommande = " + nCommande;
    break;
  }
  oCmd.ExecuteNonQuery();
  oConn.Close();
  Response.Redirect("AdminCommandes.aspx");
 }
}
