﻿using System;
using System.Data;
using System.Data.Common;
using System.Configuration;
using System.Collections;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using System.Drawing;

public partial class EtatCommandes : System.Web.UI.Page
{
 protected void Page_Load(object sender, EventArgs e)
 {
  object o = Session["CLIENT"];
  if (o == null) return;
  int numClient = (int)o;
  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString;
  DbDataAdapter oDA = dbpf.CreateDataAdapter();
  oDA.SelectCommand = oConn.CreateCommand();
  oDA.SelectCommand.CommandText = "SELECT Ouvrages.ISBN, Ouvrages.Titre, Ouvrages.Auteur, Ouvrages.Prix, "
                                  + "Commandes.DateCommande, Commandes.Etat, Commandes.DateTraitement, Commandes.Commentaire "
                                  + " FROM Ouvrages, Commandes, Clients "
                                  + " WHERE Ouvrages.ISBN = Commandes.ISBN AND Clients.ID = " + numClient
                                  + " AND Clients.ID = Commandes.IDClient";
  DataSet oDS = new DataSet();
  oDA.Fill(oDS, "MesCommandes");
  gv.DataSource = oDS.Tables[0];
  gv.DataBind();
 }

 protected void Page_PreRender(object sender, EventArgs e)
 {
  object o = Session["CLIENT"];
  if (o == null) return;
  int numClient = (int)o;
  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString;
  oConn.Open();
  DbCommand oCmd = oConn.CreateCommand();
  oCmd.CommandText = "SELECT * FROM Clients WHERE ID = " + numClient;
  DbDataReader oRdr = oCmd.ExecuteReader();
  if (oRdr != null && oRdr.Read())
  {
   zeNom.Text = (string)oRdr["NOM"];
   zePrénom.Text = (string)oRdr["PRENOM"];
   zeAdresse.Text = (string)oRdr["ADRESSE"];
   zeCP.Text = (string)oRdr["CP"];
   zeLocalité.Text = (string)oRdr["LOCALITE"];
   zePays.Text = (string)oRdr["PAYS"];
   zeEmail.Text = (string)oRdr["EMAIL"];
   zeNumCC.Text = (string)oRdr["CCNUM"];
   zeMP1.Attributes.Add("Value", (string)oRdr["MP"]);
   zeMP2.Attributes.Add("Value", (string)oRdr["MP"]);
   coCarte.SelectedValue = (string)oRdr["CCTYPE"];
   coExpMois.SelectedValue = ((int)oRdr["CCEXPMOIS"]).ToString();
   coExpAnnée.SelectedValue = ((int)oRdr["CCEXPANNEE"]).ToString();
  }
  oConn.Close();
 }
 protected void gv_RowDataBound(object sender, GridViewRowEventArgs e)
 {
  string s = "";
  if (e.Row.RowType == DataControlRowType.DataRow)
  {
   string sEtat = e.Row.Cells[5].Text;
   string sDateTraitement = e.Row.Cells[6].Text;
   DateTime dtTraitement = new DateTime();
   DateTime.TryParse(sDateTraitement, out dtTraitement);
   string sCommentaire = e.Row.Cells[7].Text;
   switch (sEtat)
   {
    case "0" : s = "Non encore traitée. " + sCommentaire; break;
    case "1" : s = "Expédié le " + dtTraitement.ToShortDateString() + ". " + sCommentaire; break;
    case "2" : s = "En attente réapprovisionnement. " + sCommentaire; break;
    case "3" : s = "Refus. " + sCommentaire; break;
   }
   e.Row.Cells[6].Text = ""; e.Row.Cells[7].Text = "";
   e.Row.Cells[5].Text = s;
  }
 }
 protected void bModifierInfos_Click(object sender, EventArgs e)
 {
  object o = Session["CLIENT"];
  if (o == null)
  {
   zaInfo.Text = "Expiration de session. Modification non effectuée";
   return;
  }
  // modifier la table des clients
  int numClient = (int)o;
  DbProviderFactory dbpf = DbProviderFactories.GetFactory("System.Data.OleDb");
  DbConnection oConn = dbpf.CreateConnection();
  oConn.ConnectionString = ConfigurationManager.ConnectionStrings["LibrairieConnectionString"].ConnectionString;
  oConn.Open();
  DbCommand oCmd = oConn.CreateCommand();
  string sNom = zeNom.Text.Replace("'", "''");
  string sPrénom = zePrénom.Text.Replace("'", "''");
  string sAdresse = zeAdresse.Text.Replace("'", "''");
  string sCP = zeCP.Text.Replace("'", "''");
  string sLocalité = zeLocalité.Text.Replace("'", "''");
  string sPays = zePays.Text.Replace("'", "''");
  string sEmail = zeEmail.Text.Replace("'", "''");
  string sNumCC = zeNumCC.Text.Replace("'", "''");
  int iExpMois, iExpAnnée;
  Int32.TryParse(coExpMois.SelectedValue, out iExpMois);
  Int32.TryParse(coExpAnnée.SelectedValue, out iExpAnnée);
  oCmd.CommandText = "UPDATE Clients "
    + "SET NOM='" + sNom + "', PRENOM='" + sPrénom + "', ADRESSE='" + sAdresse + "', CP='" + sCP
    + "', LOCALITE='" + sLocalité + "', PAYS='" + sPays + "', EMAIL='" + sEmail + "', "
    + "CCTYPE = '" + coCarte.SelectedValue + "', CCNUM='" + sNumCC + "'"
    + ", CCEXPMOIS=" + iExpMois + ", CCEXPANNEE=" + iExpAnnée + ", MP='" + zeMP1.Text + "' "
    + " WHERE ID=" + numClient;
  int n = 0;
  try
  {
   n = oCmd.ExecuteNonQuery();
   zaInfo.Text = n == 1 ? "Modification effectuée" : "Modification non effectuée";
  }
  catch (Exception)
  {
   zaInfo.ForeColor = Color.Red;
   zaInfo.Text = "La commande n'a pu pas pu être enregistrée";
  }
  oConn.Close();
 }
}
